local conf = tableCombine({}, Settings[script.name] or {})
conf.mirrors = conf.mirrors or {'.blogspot.com/', '.blogspot.ru/'}

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	uri = URI.parse(origUrl)

	if uri.host:find('%.bp%.blogspot%.com$') then
		dirUrl = origUrl:gsub('^([^/]+//[^/]+/[^/]+/[^/]+/[^/]+/[^/]+/)[^/]+', '%1d')
		return usd.setretresult(dirUrl, 0, 1)
	end


	if uri.path=='/' then
		local nextUrl = uri('/feeds/posts/default?alt=json&max-results=100')()
		for i=1, 100 do
			page = usd.get(nextUrl)
			local data = parseJsObject(page)
			debugSaveInc(logpref..'.html', page, serialize(data,nil,true))
			usd.setstatus(data.feed["openSearch$startIndex"]["$t"]..' / '..data.feed["openSearch$totalResults"]["$t"])
			for k, v in ipairs(data.feed.entry) do usd.addquery(v.link[#v.link].href) end
			nextUrl = data.feed.link[#data.feed.link]
			nextUrl = nextUrl.rel=='next' and nextUrl.href:gsub('^https:','http:')
			if not nextUrl then break end
		end
		return usd.setretresult('%done%')
	end

	page = usd.get(uri('/feeds/posts/default?alt=json&prettyprint=true&path='..escapeUC(uri.path))())
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
	if parseHeaders().CODE==404 and page:find('<title>Blog not found</title>') then return usd.setretresult('%notfound%') end

	local tmp = split(getHost(uri),'.')
	local blogname = tmp[#tmp-1]=='blogspot' and tmp[1] or table.concat(tmp,'_')

	local pref = blogname..'-'..data.feed.entry[1].published["$t"]:match('^([%d-]+)')..'-'..data.feed.entry[1].title["$t"]
	pref = filterUtf8(pref)

	local urls = {}
	local body = data.feed.entry[1].content["$t"]
	local function makeUrl(u) return getHandler(plg.tDirLink, u) and u or (u:gsub('^[^/]+//','ftp://direct/')) end
	--local function grab(u) table.insert(urls, makeUrl(u)); return '' end
	local function grab(u)
		local _, u = u:match('src=(["\'])(.-)%1')
		u = u:gsub("'",'%%27')
		table.insert(urls, makeUrl(u)); return ''
	end
	body = body:gsub('<iframe[^>]- src=[\'"]https?://[^\'"]+.-</iframe>', grab)
	body = body:gsub('<img[^>]- src=[\'"]https?://[^\'"]+[^>]->', grab)
	local l = math.max(2,#tostring(#urls))
	for k,v in ipairs(urls) do
		local p = pref..(#urls>1 and '-'..pad(k,l) or '')
		if v:find('%.bp%.blogspot%.com/') then
			local fname = urls[k]:match('/([^/]+)$')
			if fname then fname = escapeUC(unescape(unescape(fname)):gsub('[%s\'+]','_')) end
			urls[k] = urls[k]:gsub('^([^/]+//[^/]+/[^/]+/[^/]+/[^/]+/[^/]+/)[^/]+/.-$', '%1d/')..p..(fname and '-'..fname or '')
		else
			urls[k] = addNewName(v, nil, p, nil, -1)
		end
	end
	if #urls==1 then return getMirror(urls --[[, {params={newName=newName}}]] ) end
	for k, v in ipairs(urls) do usd.addquery(v) end
	usd.setretresult('%done%')
end

function OS(origUrl, dirUrl, fullName, headers)
	logpref = script.name .. '_OS'
	if dirUrl:find('%.bp%.blogspot%.com/') then
		usd.setretresult(fileRename(fullName, URI.parse(dirUrl).path:match('/([^/]+)$'), getProperExt(fullName) or -1))
	end
	--return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end

function SU(url)
	if (URI.parse(url).path or '/')=='/' then return true end
end

regDirSuccess( conf.mirrors, GDL, OS, SU )
