
--     
function GDL(origUrl) -- GetDirectLink
    local logpref = script.name .. '_GDL_v11'
    --    ; script.name -    

    local ql = {'1080', '720', '480', '380', '240'}
	local conf = Settings[script.name]
		or { qualityList = ql }
	--   usdLua_settings.lua  
	debugLog(serialize(conf))

    usd.setstatus(script.name)

    local dirUrl

	local resume = 0

	--   
	local fmt = string.match(origUrl, '#fmt=(%w+)')
	if fmt then
		resume = 1
		origUrl = origUrl:match('^([^#]+)')
	end

	script.tmp={}

	usd.setcookie('family_filter=off; ff=off; lang=en_US', 1)	--     

	local id = origUrl:match('/video/(%w+)')

	local url = 'http://www.dailymotion.com/embed/video/'..id

	debugSaveInc(logpref..'.html', usd.head(url))
	if getHost(usd.getlocation(), nil, nil, 2)~='dailymotion.com' then return getMirror({usd.getlocation()}) end

	local page = usd.get(url)
	--local data = parseJsObject(page:match('var info = ({.+)') or page:match('window.playerV5%s*=[^{]-({.-)</script>') or '')
	local data = parseJsObject(page:match('var config = (.-)</script>') or '')
	if (data or {}).context then data.context = '<del>' end
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))

	--     "HTTP/1.1 410 Gone",   .
	if string.find(usd.getheaders(), 'HTTP/%d%.%d 410 Gone') then
		usd.setretresult('%deleted%')
		return
	end

	local err = data.error or data.metadata.error
	if err then
		if err.title == 'Content rejected.'
			or err.statusCode == 404
			or err.statusCode == 410
			then
			usd.setretresult('%deleted%')
		else
			usd.setretresult('%'..err.title)
		end
		return
	end

	if data.metadata then data = data.metadata end

	local duration = math.floor(data.duration / 60).. ':' .. pad(data.duration % 60, 2)

	local title = utf8ToAnsi(entityDecode(data.title))

	local info = {}


	local urls = {} --       
	for _, v in ipairs(ql) do
		v = tonumber(v) or v
		local stream
		for kk,vv in ipairs(data.qualities and data.qualities[v] or {}) do
			if vv.type == "video/mp4" then
				stream = vv.url
				break
			end
		end
		if stream then
			local tmp = stream:match('/cdn/([^/]+)/video/')
			local codec, res = tmp:match('^(.-)%-([%dx]+)$')
			debugSaveInc(logpref..'.html', urlHead(stream,{referer=origUrl}), ('%s\r\n%s'):format(origUrl, v) )
			urls[tostring(v)] = usd.getlocation()
			local size = usd.getheaders():match('HTTP/%d%.%d 200 OK') and usd.getheaders():match('Content%-Length: (%d+)')
			size = size and string.format('%0.2f', size / 1024 / 1024) or ' ??????'

			table.insert(
				info, string.format(
					'%s MB:  ~%s %s  %s'
					, pad(size, 7, '  ')
					, pad(res, 9, '  ')
					, pad(codec, 4, '  ')
					, v
				)
			)
		end
	end

	local function download(dirUrl, name --[[, resume]])
		if conf.chunkedDownload then
			restart, info = chunkedDownload(dirUrl, name, {chunkSize=conf.chunkSize, chunkPause=conf.chunkPause, referer=origUrl})
			if restart then return end
		end
		usd.setretresult( addNewName(dirUrl, name), 0, 1 )
	end

	if fmt and urls[fmt] then
		dirUrl = urls[fmt]
		--dirUrl = addNewName(dirUrl, title)
		--usd.setretresult( dirUrl, 0, resume )
		return download(dirUrl, title)
	end

	if #info == 0 then
		local vsrc = page:match('<link rel="video_src" href="(.-)"'):gsub('&amp;','&')
		debugLog('video_src = '..vsrc)
		if vsrc and not vsrc:find('dailymotion.com/') then
			local h
			h = getHandler(plg.tDirLink, vsrc)
			if not h then
				usd.setretresult('%Unknown hosting: '..vsrc)
				return
			end
			script.tmp.vsrc = vsrc
			h(vsrc)
			return
		end
	end

	if conf.interactive then
		local dlg = {
			{duration, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		local dlg = Dialog.new(dlg, script.name)
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		q = info[tonumber(q)]:match(' (%w+)$')
		fmt = q
		usd.modquery(origUrl .. '#fmt='..fmt)
		dirUrl = urls[q]
		--dirUrl = addNewName(dirUrl, title)
		--usd.setretresult( dirUrl, 0, resume )
		return download(dirUrl, title)
	end


	--      qualityList    video . 

	for k, v in ipairs(conf.qualityList) do
		if urls[v] then
			dirUrl = urls[v]
			fmt = v
			break
		end
	end

	if not dirUrl then
		fmt, dirUrl = next(urls)	--   
	end

	usd.modquery(origUrl .. '#fmt='..fmt)

	download(dirUrl, title)
end

--   
function OS(origUrl, dirUrl, fullName) -- OnSuccess
	logpref = script.name .. '_OS'

	if script.tmp.vsrc then
		local OShandler = getHandler(plg.tOnSuccess, script.tmp.vsrc)
		if OShandler then OShandler(script.tmp.vsrc, dirUrl, fullName) end
		return
	end

	--local page = usd.get(origUrl)
	--debugSaveInc('dailymotion_com_OS.html', page)
	--local title = string.match(page, '<span class="title" title="([^"]+)">')
	----     
	--title = utf8ToAnsi(title)	--    UTF-8  ANSI
	local tmp = fileRename(fullName, title, '.mp4') --  
	return usd.setretresult(tmp) --  USD  
end

--   GetDirectLink  OnSuccess  'dailymotion.com/video/'
--regDirSuccess('dailymotion.com/video/', GDL, OS)
regDirSuccess('dailymotion.com/', GDL, OS)
regDirSuccess('//dai.ly/', GDL, OS)

-- dailymotion.com/embed/video/
-- http://www.dailymotion.com/video/xgjrs4_yyyyyyyyyy-yyyyyyy-yyyyyyy-yyyyyy-yyyyyy_animals#hp-v-v11
-- http://www.dailymotion.com/video/xril8y_holland-0-2-germany-38-0-2-m-gomez-hd_sport#
