
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	uri = URI.parse(origUrl)
	origUrl = uri()

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2, 2)

	local aid = origUrl:match('/album/(%d+)')
	local tid = origUrl:match('/album/%d+/track/(%d+)')
	local artistid = origUrl:match('/artist/(%d+)')
	--local ref = usd.getlocation()
	local ref = origUrl:gsub('^http:','https:')

	local headers = {'X-Retpath-Y: '..escapeUC(ref), 'X-Requested-With: XMLHttpRequest'}

	if not (aid or tid) and artistid then
		--local url = 'https://music.yandex.ru/api/v2.1/handlers/artist/'..artistid..'?external-domain=music.yandex.ru&overembed=no&__t='..os.time()..math.random(100,999)
		local url = 'http://music.yandex.ru/handlers/artist.jsx?artist='..artistid..'&what=albums&sort=year&dir=&external-domain=music.yandex.ru&overembed=no&__t='..os.time()..math.random(100,999)
		setHeader(headers)
		page = usd.get(url)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data,nil,true))
		setHeader(headers, true)

		local function addAlbums(data)
			for k, v in ipairs(data) do
				usd.addquery(('http://music.yandex.ru/album/%s#%s%s'):format(v.id, pad2(v.id, ('0'):rep(8)), filterUtf8(v.artists[1].name..'-'..v.year..'-'..v.title)))
			end
		end
		addAlbums(data.albums)
		--addAlbums(data.alsoAlbums)

		usd.setretresult('%done%')
		return
	end

	if aid and not tid then
		setHeader(headers)
		page = usd.get('http://music.yandex.ru/api/v2.1/handlers/album/'..aid..'?external-domain=music.yandex.ru&overembed=no&__t='..os.time()..math.random(100,999))
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data,nil,true))
		setHeader(headers, true)
		for k, v in ipairs(data.volumes[1]) do
			usd.addquery(('https://music.yandex.ru/album/%s/track/%s#%s%s'):format(aid, v.id, pad2(aid..v.id, ('0'):rep(17)), filterUtf8(v.artists[1].name..'-'..v.title..(v.version and '-'..v.version or ''))))
		end
		usd.setretresult('%done%')
		return
	end

	usd.setreferer(ref)
	setHeader(headers)
	--setXHR()
	page = usd.get(('http://music.yandex.ru/api/v2.1/handlers/tracks?tracks=%s:%s&external-domain=music.yandex.ru&overembed=no&__t=%s%s'):format(tid,aid,os.time(),math.random(100,999)))
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))


	script.tmp.newName = filterUtf8(table.concat(
		{
			data[1].artists[1].name
            , data[1].albums[1].year
            , data[1].albums[1].title
            , pad(data[1].albums[1].trackPosition.index, 2)
			, data[1].title
			, data[1].version
		}, '-')
	)

	usd.waittime(2,2)

	usd.setreferer(ref)
	--setXHR()
	setHeader(headers)
	page = usd.get(('http://music.yandex.ru/api/v2.1/handlers/track/%s:%s/web-album_track-album-album-main/download/m?hq=1&external-domain=music.yandex.ru&overembed=no&__t=%s%s'):format(tid,aid,os.time(),math.random(100,999)))
	data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))

	usd.setreferer(ref)
	--setXHR()
	setHeader(headers)
	page = usd.get((data.src:gsub('^https:','http:')))
	data = {}
	for k, v in page:match('<download%-info>(.-)</download%-info>'):gmatch('<([^>]+)>([^<]+)</%1>') do data[k]=v end
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))

	--setXHR(true)
	setHeader(headers, true)

	function makeHash(str)
		local md5 = ltn12ce.digest('md5')
		md5:update('XGRlBW9FXlekgbPrRHuSiA'..str)
		return (md5:finish():gsub('.',function(b) return bit.tohex(b:byte(),2)end))
	end

	dirUrl = ('http://%s/get-mp3/%s/%s%s?track-id=%s&play=false'):format(data.host, makeHash(data.path:sub(2)..data.s), data.ts, data.path, tid )

	usd.setretresult(dirUrl, 1, 1)
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, '.mp3'))
end


regDirSuccess( '//music.yandex.ru/', GDL, OS)
