
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v04'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	local function api(url)
		local page = usd.get(url)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true))
		return data
	end

	script.tmp={}

	uri = URI.parse(origUrl)

	local id = uri.path:match('^/folder/(%w+)')
		or uri.path:match('^/(%w+)')
		or uri.fragment

	local data = api('http://api.oboom.com/1/ls?item='..id)
	if data[1]~=200 then return usd.setretresult('%notfound%') end

	if data[2].type=='folder' then
		for k, v in ipairs(data[3]) do
			usd.addquery('http://www.oboom.com/'..v.id..'/'..filterUtf8(v.name))
		end
		usd.setretresult('%done%')
		return
	end


	script.tmp.newName = filterName(utf8ToAnsi(data[2].name), true)

	if setPusdName(script.tmp.newName) then return end

	local token = api('http://www.oboom.com/1/guestsession')[2]

	local config = api('http://www.oboom.com/1.0/download/config?token='..token)

	if config[2]=="blocked_wait" then
		if Timeout.get(getHost(uri), nil, 'ignoreIP') then return end
		--local lastDownload = usd.getoption(plg.plgname, script.name .. '_lastDownload', os.time())
		--local wait = (lastDownload + 60*60) - os.time() + 10
		--usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
		usd.setretresult('%'..config[2])
		return
	end

	usd.waittime(config[2].waiting)

	local ticket

	if config[2].captcha=='oboom' then
		for i=1, captchaAttempts do
			local r = queryCaptcha('http://www.oboom.com/captcha/'..config[2].oboom_captcha..'.jpg')
			ticket = api(('http://www.oboom.com/1.0/download/ticket?recaptcha_challenge_field=oboom:%s&recaptcha_response_field=%s&download_id=%s&token=%s'):format(config[2].oboom_captcha, r, id, token))
			if ticket[1]==200 then break end
		end
	else
		local r, t, c = queryReCaptcha(config[2].recaptcha, 0, nil, nil, nil, true) -- gooCheck
		ticket = api(('http://www.oboom.com/1.0/download/ticket?recaptcha_challenge_field=%s&recaptcha_response_field=%s&download_id=%s&token=%s'):format(c, r, id, token))
	end

	local dl = api(('http://api.oboom.com/1/dl?item=%s&token=%s&auth=%s'):format(id,ticket[2],ticket[3]))
	dirUrl = ('http://%s/1.0/dlh?ticket=%s'):format(dl[2], dl[3])

	usd.setretresult(dirUrl, 1, 1)

	Timeout.set(getHost(uri), 60*60, nil, 'ignoreIP')

	--usd.setoption(plg.plgname, script.name..'_lastDownload', os.time() )
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( '.oboom.com/', GDL, OS)
