
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v07'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	script.tmp={}

	local conf = Settings[script.name] or { lossless=false }
	debugLog('conf='..serialize(conf,nil,nil,true))

	Storage[script.name] = Storage[script.name] or {}
	local st = Storage[script.name]
	debugLog('st='..serialize(st,nil,nil,true))

	local function getCID()
		usd.setreferer('')
		local page = usd.get('http://soundcloud.com/')
		debugSaveInc(logpref..'.html', page)
		local tmp = page:match('<script src="(https://[^.]+%.sndcdn%.com/assets/app%-[%x-]+%.js)"')
		tmp = tmp:gsub('^https:','http:')
		page = usd.get(tmp)
		local cid = page:match('client_id:"(%w+)"')
		debugSaveInc(logpref..'.html', page, cid or '<no cid>')
		usd.setreferer('')
		return cid
	end

	local client_id = conf.client_id or st.client_id or getCID()
	st.client_id = client_id

	uri = URI.parse(origUrl)

	local function api2(req, rdata)
		rdata = rdata or {}
		rdata.client_id = client_id
		local url = ('http://api.soundcloud.com/%s.json?%s'):format(req, tableConcat(rdata,'=','&'))
		local page = usd.get(url)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
		return data
	end
	local function api(req, rdata)
		local data = api2(req, rdata)
		if not data and not conf.client_id and parseHeaders().CODE==401 then
			client_id = getCID()
			st.client_id = client_id
			data = api2(req, rdata)
		end
		return data
	end

	local function process(data)
		debugLog('data.kind='..tostring(data.kind))
		if data.kind=='user' then
			local id = data.id
			data = api('users/'..id..'/playlists')
			for k, v in ipairs(data) do usd.addquery(v.permalink_url) end
			data = api('users/'..id..'/tracks')
			for k, v in ipairs(data) do usd.addquery(v.permalink_url) end
			usd.setretresult('%done%')

		elseif data.kind=='playlist' then
			for k, v in ipairs(data.tracks) do usd.addquery(v.permalink_url) end
			usd.setretresult('%done%')

		elseif data.kind=='track' then
			script.tmp.newName = filterName(utf8ToAnsi(data.user.username..'-'..data.title), true)
			local f = data.original_format or ''
			-- aiff, wav, flac, m4a, mp3
			dirUrl = data.downloadable and (f~="wav" and f~='aiff') and (f~='flac' or conf.lossless) and data.download_url or data.stream_url

            if not dirUrl then
            end

            usd.setreferer(origUrl)

			if dirUrl then
				dirUrl = dirUrl:gsub('^https:','http:')..(dirUrl:find('?',1,true) and '&' or '?')..'client_id='..client_id
				usd.setreferer(origUrl)
				usd.relocationmode(0)
				debugSaveInc(logpref..'.html', usd.get(dirUrl) )
				local h = parseHeaders(usd.getheaders())

				if h.CODE==404 then return usd.setretresult('%notfound%') end

				if h.LOCATION1 then uri = uri(h.LOCATION1) end
			else
            	local page = usd.get('http://api.soundcloud.com/i1/tracks/'..data.id..'/streams?client_id='..client_id)
				local data = parseJsObject(page)
				debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
				dirUrl = data.http_mp3_128_url
				uri = uri(dirUrl)
	            usd.setreferer(origUrl)
			end

			local https = tableKeys('soundcloud.hs.llnwd.net')

			if https[uri.host] then
				uri=uri('http://vk.com/away.php?to='..escapeUC(uri()))
				usd.setcookie('remixlang=0')	-- vk
				getResumeFlag(nil, true)
			else
				uri.scheme='http'
			end
			--dirUrl = addNewName(uri(), script.tmp.newName) -- cf-media.sndcdn.com
			dirUrl = uri()
			usd.setreferer(origUrl)
			usd.setretresult(dirUrl, 0, 1)

		else
			usd.setretresult('%unknown type')
		end
	end -- process

--https://w.soundcloud.com/player/?url=http%3A%2F%2Fapi.soundcloud.com%2Ftracks%2F123&visual=true&liking=false&sharing=false&auto_play=false&show_comments=false&continuous_play=false&origin=tumblr
	if uri.host=='w.soundcloud.com' then
		origUrl = unescape(uri.query:match('url=(http[^&]+)'))
		uri = URI.parse(origUrl)
	end


	local data

	local secret_token = origUrl:match('[&?]secret_token=([^&]+)')

--http://api.soundcloud.com/tracks/123/stream
	if uri.host=='api.soundcloud.com' then
		--data = api(uri.path:match('^/([^/]+/[^/]+)'))
		data = api(uri.path:match('^/([^/]+/[^/.]+)'), {secret_token=secret_token})
		origUrl = data.permalink_url
	else
		data = api('resolve', {url=origUrl})
	end

	if not data then
		local h = parseHeaders()
		if h.CODE==401 then return usd.setretresult('%Bad client_id ?') end
		usd.setretresult(('%%error %s %s'):format(h.CODE, h.REASON))
		return
	end

	if ((data.errors or {})[1] or {}).error_message == "404 - Not Found" then return usd.setretresult('%notfound%') end

	if data.permalink_url then usd.modquery(data.permalink_url) end

	if data.kind then
		process(data)
	else
		for k, v in ipairs(data) do process(v) end
	end


end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	--local ext = URI.parse(dirUrl).path:match('%.%w+$')
	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end


regDirSuccess( '//soundcloud.com/', GDL, OS)
regDirSuccess( '.soundcloud.com/', GDL, OS)
regDirSuccess( '//snd.sc/', GDL, OS)
