
function GDL(origUrl)
    logpref = script.name .. '_GDL_v15'
    usd.setstatus(script.name)
	local dirUrl, page, form

	local conf = Settings[script.name] or {freeDelay = 3*60*60}

	--Storage[script.name] = Storage[script.name] or {}
	--local st = Storage[script.name]

	--debugLog('Since last download: '..os.time()-st.lastDownload)

	page = usd.head(origUrl)
	debugSaveInc(logpref..'.html', page)
	if parseHeaders().CODE==404 or parseHeaders().CODE==451 then return usd.setretresult('%notfound%') end
	if page:lower():find('content%-disposition:') then
		usd.setretresult(usd.getlocation(), 1, 0)
		return
	end

	page = usd.get(usd.getlocation())
	debugSaveInc(logpref..'.html', page)

	local uri = URI.parse(usd.getlocation())
	if uri.path:find('^/404$') or uri.path:find('^/410/')		-- http://uploaded.net/404
	then return usd.setretresult('%notfound%') end

	local folder = page:match('<table id="fileList">.-</table>')
	if folder then
		local maxw = plg.gettextextent(('w'):rep(8))
		for f in folder:match('<tbody>.-</tbody>'):gmatch('<tr.-</tr>') do
			local url, id, name = f:match('href="(file/([^/]+)[^"]*)"[^>]*>([^<]+)')
			name = filterUtf8(entityDecode(name))
			local size = f:match('<small class="cL"[^>]*>([^<]+)</small>')
			size = size and pad(size:gsub('%s+','_'),9) or ''
			usd.addquery(('http://uploaded.net/%s#%s%s_%s'):format(url,pad2(id,maxw), size, name))
		end
		usd.setretresult('%done%')
		return
	end

	if page:find('var%s+free_enabled%s*=%s*false;') then
		usd.setretresult("%No free slots")
		return
	end

	local id = uri.path:match('^/file/(%w+)')


	local data = urlGet('http://uploaded.net/api/download/Info?auth='..id,{json=true, logpref=logpref})
    if data.info.size > 1024*1024*1024 then
    	debugLog('File is too big')
    	usd.setretresult('%notfound%')
    	return
    end

	local myIP
	if conf.freeDelay then
		--local extIP = Settings['<misc>'].extIP or 'http://ip-api.com/csv/?fields=query'
		local data2 = base64.decode(data.key) or '<no data>'
		debugLog(data2)
		myIP = data2:match(';(%d+%.%d+%.%d+%.%d+)')
		if Timeout.get(script.name, uri(), myIP) then return end
	end

	local wait = page:match('<span>Current waiting period: <span>(%d+)</span> seconds</span>')
		or page:match('<meta name="wait" content="(%d+)">')

	local slot = usd.post(uri('/io/ticket/slot/'..id)(), '%simple%')
	debugSaveInc(logpref..'.html', slot)
	if not slot:find('succ"?:true') then -- {succ:true} -- {"succ":true}
		usd.setretresult("%No free slots?")
		return
	end

	usd.waittime(wait+2,2)

	local key = '6Lcqz78SAAAAAPgsTYF3UlGf2QFQCNuPMenuyHF3%20'	-- cloudzer.net & uploaded.net

	form = Form.make{ action=uri('/io/ticket/captcha/'..id)(), method='POST' }
	queryReCaptcha{key=key, check=true, form=form}
	if form.inputs.recaptcha_response_field=='' then return usd.setretresult('%no captcha')	end
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	local data = parseJsObject(page) or {}

	if conf.freeDelay then Timeout.set(script.name, conf.freeDelay, nil, myIP) end

	if data.err then
		usd.setretresult('%'..data.err:gsub('<[^>]+>',' '))
		return
	end

	dirUrl = data and data.type == 'download' and data.url
	usd.setretresult(dirUrl, 1, 0)


end

regDirSuccess('//uploaded.to/', GDL)
regDirSuccess('//uploaded.net/', GDL)
regDirSuccess('.uploaded.net/', GDL)
regDirSuccess('//ul.to/', GDL)
