local conf = Settings[script.name] or {}
conf.mirrors = conf.mirrors or {'//youwatch.org/', '//ay8ou8ohth.com/', '//voodaith7e.com/'}
conf.qualityList = conf.qualityList or {720, 480}

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	debugLog('conf='..serialize(conf,nil,nil,true))

	local fmt = tonumber(origUrl:match('#fmt=(%w+)') or '')

	uri = URI.parse(origUrl)
	local id = uri.p[1]:match('^embed%-('..('[%da-z]'):rep(12)..')') or uri.p[1]
	origUrl = 'http://youwatch.org/'..id
	uri = URI.parse(origUrl)

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find('</span> File Not Found</h1>')
		or page:find('<b>Reason for deletion:</b>')
		then
		return usd.setretresult('%notfound%')
	end

	local title = page:match('<h3 id="title">(.-)</h3>')
	title = title and utf8ToAnsi(ROT13(title)) or id
	script.tmp.newName = filterName(title, true)

	local sources
	local urls, info = {}, {}

	for i=1,10 do
		tmp = page:match('<iframe[^>]-src="([^/]+//[^/]+/embed%-............[.-][^"]+)"')
		if not tmp then break end
		page = usd.get(tmp)
		sources = page:match('sources: %[{.-}%]')
		sources = sources and parseJsObject(sources)
		debugSaveInc(logpref..'.html', page, sources and serialize(sources, nil, true))
	end

	local ref = usd.getlocation()

	for k, v in ipairs(sources) do urls[v.label] = v.file end

	if conf.interactive and not fmt then
		for k, v in ipairs(conf.qualityList) do
			if urls[v] then
				debugSaveInc(logpref..'.html', usd.head(urls[v]), ('%s\r\n%s'):format(origUrl, v) )
				usd.setreferer(ref)
				local size = parseHeaders(usd.getheaders()).SIZE
				size = size and ('%0.2f'):format(size / 1024 / 1024) or ' ??????'
				table.insert(info, ('%s: %s MB'):format(pad(v,4,'  '), pad(size,7,'  ')))
			end
		end
		local duration = page:match('duration:"(%d+)"')
		duration = duration and s2hms(duration) or '--:--:--'

		local dlg = {
			{duration, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		local dlg = Dialog.new(dlg, script.name)
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		fmt = tonumber(info[tonumber(q)]:match('^%s*(%d+)'))
	end

	if not fmt then
		for k, v in ipairs(conf.qualityList) do
			if urls[v] then
				fmt = v
				break
			end
		end
	end

	dirUrl = urls[fmt]

	if dirUrl:match('^https?://[^/]+/i/youwatch%.mp4$') then return usd.setretresult('%plugin error') end

	dirUrl = addNewName(dirUrl, script.tmp.newName)

	usd.modquery(origUrl..'#fmt='..fmt)

	usd.setretresult(dirUrl, math.random(2,4), 1)
end

function OS(origUrl, dirUrl, fullName, headers)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end


regDirSuccess( conf.mirrors, GDL, OS, {canRecode=true})
